#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "cat.h"

#include "savecat.h"

static int write_entry(GNode *node, gpointer data)
{
    int fd = GPOINTER_TO_INT(data);
    Item *item = ITEM(node->data);

    if (item) {
	write(fd, item, sizeof(Item));
	write(fd, item->name, item->namelen);
    }
    return FALSE;
}

static void write_disk(gpointer data, gpointer user_data)
{
    int fd = GPOINTER_TO_INT(user_data);
    Disk *disk = DISK(data);
    Item last;
    char *diskid = "\xde\xad\xbe\xef";

    /* let GTK update the UI */
    while (gtk_events_pending())
	gtk_main_iteration();
    
    /* write disk ID */
    write(fd, diskid, 4);
    write(fd, disk->label, 20);
    write(fd, &disk->n_dirs, sizeof(unsigned int));
    write(fd, &disk->n_files, sizeof(unsigned int));
    /* future expansion */
    write(fd, "\xca\xca\x00\x00\xca\xca\x00\x00", 8);
    g_node_traverse(disk->tree, G_PRE_ORDER, G_TRAVERSE_ALL, -1,
	    write_entry, user_data);
    
    /* write end marker */
    memset(&last, 0, sizeof(Item));
    last.size = 0xffffffff;
    write(fd, &last, sizeof(Item));
}

int savecat(Catalog *cat)
{
    int fd;
    char *catid = "catalog\xff\xff";
    unsigned int tmp;

    fd = open(cat->catfile, O_RDWR | O_CREAT, 0644);
    write(fd, catid, 9);
    
    tmp = g_list_length(cat->disks);
    write(fd, &tmp, sizeof(unsigned int));

    g_list_foreach(cat->disks, write_disk, GINT_TO_POINTER(fd));

    close(fd);
    return TRUE;
}
